## zhmcclient 0.21.0

=== Makefile ===
# ------------------------------------------------------------------------------
# Makefile for zhmcclient project
#
# Basic prerequisites for running this Makefile, to be provided manually:
#   One of these OS platforms:
#     Windows with CygWin
#     Linux (any)
#     OS-X
#   These commands on all OS platforms:
#     make (GNU make)
#     bash
#     rm, mv, find, tee, which
#   These commands on all OS platforms in the active Python environment:
#     python (or python3 on OS-X)
#     twine
#   These commands on Linux and OS-X:
#     uname
# Environment variables:
#   PYTHON_CMD: Python command to use (OS-X needs to distinguish Python 2/3)
#   PIP_CMD: Pip command to use (OS-X needs to distinguish Python 2/3)
#   PACKAGE_LEVEL: minimum/latest - Level of Python dependent packages to use
# Additional prerequisites for running this Makefile are installed by running:
#   make develop
# ------------------------------------------------------------------------------

# Python / Pip commands
ifndef PYTHON_CMD
  PYTHON_CMD := python
endif
ifndef PIP_CMD
  PIP_CMD := pip
endif

# Package level
ifndef PACKAGE_LEVEL
  PACKAGE_LEVEL := latest
endif
ifeq ($(PACKAGE_LEVEL),minimum)
  pip_level_opts := -c minimum-constraints.txt
else
  ifeq ($(PACKAGE_LEVEL),latest)
    pip_level_opts := --upgrade
  else
    $(error Error: Invalid value for PACKAGE_LEVEL variable: $(PACKAGE_LEVEL))
  endif
endif

# Determine OS platform make runs on
ifeq ($(OS),Windows_NT)
  PLATFORM := Windows
else
  # Values: Linux, Darwin
  PLATFORM := $(shell uname -s)
endif

# Name of this Python package (top-level Python namespace + Pypi package name)
package_name := zhmcclient
mock_package_name := zhmcclient_mock

# Package version (full version, including any pre-release suffixes, e.g. "0.1.0-alpha1")
# May end up being empty, if pbr cannot determine the version.
package_version := $(shell $(PYTHON_CMD) -c "$$(printf 'try:\n from pbr.version import VersionInfo\nexcept ImportError:\n pass\nelse:\n print(VersionInfo(\042$(package_name)\042).release_string())\n')")

# Python major version
python_major_version := $(shell $(PYTHON_CMD) -c "import sys; sys.stdout.write('%s'%sys.version_info[0])")

# Python major+minor version for use in file names
python_version_fn := $(shell $(PYTHON_CMD) -c "import sys; sys.stdout.write('%s%s'%(sys.version_info[0],sys.version_info[1]))")

# Directory for the generated distribution files
dist_dir := dist

# Distribution archives (as built by setup.py)
bdist_file := $(dist_dir)/$(package_name)-$(package_version)-py2.py3-none-any.whl
sdist_file := $(dist_dir)/$(package_name)-$(package_version).tar.gz

# Windows installable (as built by setup.py)
win64_dist_file := $(dist_dir)/$(package_name)-$(package_version).win-amd64.exe

# dist_files := $(bdist_file) $(sdist_file) $(win64_dist_file)
dist_files := $(bdist_file) $(sdist_file)

# Source files in the packages
package_py_files := \
    $(wildcard $(package_name)/*.py) \
    $(wildcard $(package_name)/*/*.py) \
    $(wildcard $(mock_package_name)/*.py) \
    $(wildcard $(mock_package_name)/*/*.py) \

# Directory for generated API documentation
doc_build_dir := build_doc

# Directory where Sphinx conf.py is located
doc_conf_dir := docs

# Documentation generator command
doc_cmd := sphinx-build
doc_opts := -v -d $(doc_build_dir)/doctrees -c $(doc_conf_dir) .

# Dependents for Sphinx documentation build
doc_dependent_files := \
    $(doc_conf_dir)/conf.py \
    $(wildcard $(doc_conf_dir)/*.rst) \
    $(wildcard $(doc_conf_dir)/notebooks/*.ipynb) \
    $(package_py_files) \

# Directory with test source files
test_dir := tests

# Test log
test_unit_log_file := test_unit_$(python_version_fn).log
test_end2end_log_file := test_end2end_$(python_version_fn).log

# Source files with test code
test_unit_py_files := \
    $(wildcard $(test_dir)/unit/*.py) \
    $(wildcard $(test_dir)/unit/*/*.py) \
    $(wildcard $(test_dir)/unit/*/*/*.py) \

test_end2end_py_files := \
    $(wildcard $(test_dir)/end2end/*.py) \
    $(wildcard $(test_dir)/end2end/*/*.py) \
    $(wildcard $(test_dir)/end2end/*/*/*.py) \

test_common_py_files := \
    $(wildcard $(test_dir)/common/*.py) \
    $(wildcard $(test_dir)/common/*/*.py) \
    $(wildcard $(test_dir)/common/*/*/*.py) \

# Determine whether py.test has the --no-print-logs option.
pytest_no_log_opt := $(shell py.test --help 2>/dev/null |grep '\--no-print-logs' >/dev/null; if [ $$? -eq 0 ]; then echo '--no-print-logs'; else echo ''; fi)

# Flake8 config file
flake8_rc_file := setup.cfg

# PyLint config file
pylint_rc_file := .pylintrc

# Source files for check (with PyLint and Flake8)
check_py_files := \
    setup.py \
    $(package_py_files) \
    $(test_unit_py_files) \
		$(test_end2end_py_files) \
		$(test_common_py_files) \
		$(doc_conf_dir)/conf.py \
    $(wildcard docs/notebooks/*.py) \
    $(wildcard tools/cpcinfo) \
    $(wildcard tools/cpcdata) \

ifdef TESTCASES
pytest_opts := -k $(TESTCASES)
else
pytest_opts :=
endif

# Files to be built
ifeq ($(PLATFORM),Windows)
build_files := $(win64_dist_file)
else
build_files := $(bdist_file) $(sdist_file)
endif

# Files the distribution archive depends upon.
dist_dependent_files := \
    setup.py setup.cfg \
    README.rst \
    requirements.txt \
    $(wildcard *.py) \
    $(package_py_files) \

# No built-in rules needed:
.SUFFIXES:

.PHONY: help
help:
	@echo 'Makefile for $(package_name) project'
	@echo 'Package version will be: $(package_version)'
	@echo 'Uses the currently active Python environment: Python $(python_version_fn)'
	@echo 'Valid targets are (they do just what is stated, i.e. no automatic prereq targets):'
	@echo '  develop    - Prepare the development environment by installing prerequisites'
	@echo '  install    - Install package in active Python environment'
	@echo '  check      - Run Flake8 on sources and save results in: flake8.log'
	@echo '  pylint     - Run PyLint on sources and save results in: pylint.log'
	@echo '  test       - Run unit tests (and test coverage) and save results in: $(test_unit_log_file)'
	@echo '               Does not include install but depends on it, so make sure install is current.'
	@echo '               Env.var TESTCASES can be used to specify a py.test expression for its -k option'
	@echo '  end2end    - Run end2end tests and save results in: $(test_end2end_log_file)'
	@echo '               Env.var TESTCPC can be used to specify the name of a real CPC (default: mocked CPC)'
	@echo '               Env.var TESTCASES can be used to specify a py.test expression for its -k option'
	@echo '  build      - Build the distribution files in: $(dist_dir)'
	@echo '               On Windows, builds: $(win64_dist_file)'
	@echo '               On Linux + OSX, builds: $(bdist_file) $(sdist_file)'
	@echo '  builddoc   - Build documentation in: $(doc_build_dir)'
	@echo '  all        - Do all of the above'
	@echo '  uninstall  - Uninstall package from active Python environment'
	@echo '  upload     - Upload the distribution files to PyPI (includes uninstall+build)'
	@echo '  clean      - Remove any temporary files'
	@echo '  clobber    - Remove any build products (includes uninstall+clean)'
	@echo '  pyshow     - Show location and version of the python and pip commands'
	@echo 'Environment variables:'
	@echo '  PACKAGE_LEVEL="minimum" - Install minimum version of dependent Python packages'
	@echo '  PACKAGE_LEVEL="latest" - Default: Install latest version of dependent Python packages'
	@echo '  PYTHON_CMD=... - Name of python command. Default: python'
	@echo '  PIP_CMD=... - Name of pip command. Default: pip'

.PHONY: _check_version
_check_version:
ifeq (,$(package_version))
	@echo 'Error: Package version could not be determine: (requires pbr; run "make develop")'
	@false
else
	@true
endif

.PHONY: _pip
_pip:
	$(PYTHON_CMD) remove_duplicate_setuptools.py
	@echo 'Installing/upgrading pip, setuptools, wheel and pbr with PACKAGE_LEVEL=$(PACKAGE_LEVEL)'
	$(PYTHON_CMD) -m pip install $(pip_level_opts) pip setuptools wheel pbr

.PHONY: develop
develop: _pip dev-requirements.txt requirements.txt
	@echo 'Installing runtime and development requirements with PACKAGE_LEVEL=$(PACKAGE_LEVEL)'
	$(PIP_CMD) install $(pip_level_opts) -r dev-requirements.txt
	@echo '$@ done.'

.PHONY: build
build: $(build_files)
	@echo '$@ done.'

.PHONY: builddoc
builddoc: html
	@echo '$@ done.'

.PHONY: html
html: $(doc_build_dir)/html/docs/index.html
	@echo '$@ done.'

$(doc_build_dir)/html/docs/index.html: Makefile $(doc_dependent_files)
	rm -fv $@
	$(doc_cmd) -b html $(doc_opts) $(doc_build_dir)/html
	@echo "Done: Created the HTML pages with top level file: $@"

.PHONY: pdf
pdf: Makefile $(doc_dependent_files)
	rm -fv $@
	$(doc_cmd) -b latex $(doc_opts) $(doc_build_dir)/pdf
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(doc_build_dir)/pdf all-pdf
	@echo "Done: Created the PDF files in: $(doc_build_dir)/pdf/"
	@echo '$@ done.'

.PHONY: man
man: Makefile $(doc_dependent_files)
	rm -fv $@
	$(doc_cmd) -b man $(doc_opts) $(doc_build_dir)/man
	@echo "Done: Created the manual pages in: $(doc_build_dir)/man/"
	@echo '$@ done.'

.PHONY: docchanges
docchanges:
	$(doc_cmd) -b changes $(doc_opts) $(doc_build_dir)/changes
	@echo
	@echo "Done: Created the doc changes overview file in: $(doc_build_dir)/changes/"
	@echo '$@ done.'

.PHONY: doclinkcheck
doclinkcheck:
	$(doc_cmd) -b linkcheck $(doc_opts) $(doc_build_dir)/linkcheck
	@echo
	@echo "Done: Look for any errors in the above output or in: $(doc_build_dir)/linkcheck/output.txt"
	@echo '$@ done.'

.PHONY: doccoverage
doccoverage:
	$(doc_cmd) -b coverage $(doc_opts) $(doc_build_dir)/coverage
	@echo "Done: Created the doc coverage results in: $(doc_build_dir)/coverage/python.txt"
	@echo '$@ done.'

.PHONY: pyshow
pyshow:
	which $(PYTHON_CMD)
	$(PYTHON_CMD) --version
	which $(PIP_CMD)
	$(PIP_CMD) --version
	@echo '$@ done.'

.PHONY: check
check: flake8.log
	@echo '$@ done.'

.PHONY: pylint
pylint: pylint.log
	@echo '$@ done.'

.PHONY: install
install: _pip requirements.txt setup.py setup.cfg $(package_py_files)
	@echo 'Installing $(package_name) (editable) with PACKAGE_LEVEL=$(PACKAGE_LEVEL)'
	$(PIP_CMD) install $(pip_level_opts) -r requirements.txt
	$(PIP_CMD) install -e .
	$(PYTHON_CMD) -c "import $(package_name); print('ok, version=%r'%$(package_name).__version__)"
	$(PYTHON_CMD) -c "import $(mock_package_name); print('ok')"
	@echo 'Done: Installed $(package_name)'
	@echo '$@ done.'

.PHONY: uninstall
uninstall:
	bash -c '$(PIP_CMD) show $(package_name) >/dev/null; if [ $$? -eq 0 ]; then $(PIP_CMD) uninstall -y $(package_name); fi'
	@echo '$@ done.'

.PHONY: test
test: $(test_unit_log_file)
	@echo '$@ done.'

.PHONY: clobber
clobber: uninstall clean
	rm -Rf $(doc_build_dir) htmlcov .tox
	rm -f pylint.log flake8.log test_*.log $(bdist_file) $(sdist_file) $(win64_dist_file)
	@echo 'Done: Removed all build products to get to a fresh state.'
	@echo '$@ done.'

.PHONY: clean
clean:
	rm -Rf build .cache $(package_name).egg-info .eggs
	rm -f MANIFEST MANIFEST.in AUTHORS ChangeLog .coverage
	find . -name "*.pyc" -delete -o -name "__pycache__" -delete -o -name "*.tmp" -delete -o -name "tmp_*" -delete
	@echo 'Done: Cleaned out all temporary files.'
	@echo '$@ done.'

.PHONY: all
all: develop install check pylint test build builddoc
	@echo '$@ done.'

.PHONY: upload
upload: _check_version uninstall $(dist_files)
ifeq (,$(findstring .dev,$(package_version)))
	@echo '==> This will upload $(package_name) version $(package_version) to PyPI!'
	@echo -n '==> Continue? [yN] '
	@bash -c 'read answer; if [ "$$answer" != "y" ]; then echo "Aborted."; false; fi'
	twine upload $(dist_files)
	@echo 'Done: Uploaded $(package_name) version to PyPI: $(package_version)'
	@echo '$@ done.'
else
	@echo 'Error: A development version $(package_version) of $(package_name) cannot be uploaded to PyPI!'
	@false
endif

# Distribution archives.
$(bdist_file): _check_version Makefile $(dist_dependent_files)
ifneq ($(PLATFORM),Windows)

=== debian/changelog ===
zhmcclient (0.21.0-0ubuntu1) disco; urgency=medium

  * Initial release (LP: #1805367)

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 27 Nov 2018 18:55:21 +0000

## zhmcclient 0.22.0

=== Makefile ===
--- 
+++ 
@@ -37,9 +37,11 @@
 endif
 ifeq ($(PACKAGE_LEVEL),minimum)
   pip_level_opts := -c minimum-constraints.txt
+  pip_level_opts_new :=
 else
   ifeq ($(PACKAGE_LEVEL),latest)
     pip_level_opts := --upgrade
+    pip_level_opts_new := --upgrade-strategy eager
   else
     $(error Error: Invalid value for PACKAGE_LEVEL variable: $(PACKAGE_LEVEL))
   endif
@@ -178,8 +180,8 @@
 	@echo 'Package version will be: $(package_version)'
 	@echo 'Uses the currently active Python environment: Python $(python_version_fn)'
 	@echo 'Valid targets are (they do just what is stated, i.e. no automatic prereq targets):'
+	@echo '  install    - Install package in active Python environment'
 	@echo '  develop    - Prepare the development environment by installing prerequisites'
-	@echo '  install    - Install package in active Python environment'
 	@echo '  check      - Run Flake8 on sources and save results in: flake8.log'
 	@echo '  pylint     - Run PyLint on sources and save results in: pylint.log'
 	@echo '  test       - Run unit tests (and test coverage) and save results in: $(test_unit_log_file)'
@@ -222,7 +224,7 @@
 .PHONY: develop
 develop: _pip dev-requirements.txt requirements.txt
 	@echo 'Installing runtime and development requirements with PACKAGE_LEVEL=$(PACKAGE_LEVEL)'
-	$(PIP_CMD) install $(pip_level_opts) -r dev-requirements.txt
+	$(PIP_CMD) install $(pip_level_opts) $(pip_level_opts_new) -r dev-requirements.txt
 	@echo '$@ done.'
 
 .PHONY: build
@@ -297,7 +299,7 @@
 .PHONY: install
 install: _pip requirements.txt setup.py setup.cfg $(package_py_files)
 	@echo 'Installing $(package_name) (editable) with PACKAGE_LEVEL=$(PACKAGE_LEVEL)'
-	$(PIP_CMD) install $(pip_level_opts) -r requirements.txt
+	$(PIP_CMD) install $(pip_level_opts) $(pip_level_opts_new) -r requirements.txt
 	$(PIP_CMD) install -e .
 	$(PYTHON_CMD) -c "import $(package_name); print('ok, version=%r'%$(package_name).__version__)"
 	$(PYTHON_CMD) -c "import $(mock_package_name); print('ok')"
@@ -346,6 +348,3 @@
 	@false
 endif
 
-# Distribution archives.
-$(bdist_file): _check_version Makefile $(dist_dependent_files)
-ifneq ($(PLATFORM),Windows)

=== requirements.txt ===
# Pip requirements file for zhmcclient runtime dependencies.
#
# The order of packages is significant, because pip processes them in the order
# of appearance. Changing the order has an impact on the overall integration
# process, which may cause wedges in the gate later.

# Make sure that the package versions in minimum-constraints.txt are also
# the minimum versions required in requirements.txt and dev-requirements.txt.


# Direct dependencies (except pip, setuptools, wheel):

decorator>=4.0.10 # new BSD
pbr>=1.10.0 # Apache-2.0
pytz>=2016.10 # MIT
requests>=2.20.0 # Apache-2.0
six>=1.10.0 # MIT
stomp.py>=4.1.15 # Apache


# Indirect dependencies (commented out, only listed to document their license):

# certifi # ISC, from requests>=2.20
# chardet # LGPL, from requests>=2.20
# idna # BSD-like, from requests>=2.20
# urllib3 # MIT, from requests>=2.20

=== debian/changelog ===
zhmcclient (0.22.0-0ubuntu1) disco; urgency=medium

  * New upstream release

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 17 Jan 2019 11:25:20 +0000

=== debian/control ===
Source: zhmcclient
Section: python
Priority: optional
Maintainer: Dimitri John Ledkov <xnox@ubuntu.com>
Build-Depends: debhelper (>= 11),
 dh-python,
 python3-all,
 python3-setuptools,
 python3-pytest,
 python3-requests,
 python3-decorator,
 python3-tz,
 python3-stomp,
 python3-requests-mock,
 python3-yaml,
 python3-testfixtures,
 python3-pbr,
 python3-mock,
Standards-Version: 4.1.3
Homepage: https://github.com/zhmcclient/python-zhmcclient
Testsuite: autopkgtest-pkg-python

Package: python3-zhmcclient
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: library for the IBM Z HMC Web Services API
 The HMC Web Services API is the access point for any external tools
 to manage the IBM Z or LinuxONE platform. It supports management of
 the lifecycle and configuration of various platform resources, such
 as partitions, CPU, memory, virtual switches, I/O adapters, and more.
 .
 The zhmcclient package encapsulates both protocols supported by the
 HMC Web Services API:
 .
 - REST over HTTPS for request/response-style operations driven by the
 client. Most of these operations complete synchronously, but some
 long-running tasks complete asynchronously.
 .
 - JMS (Java Messaging Services) for notifications from the HMC to the
 client. This is used for notification about changes in the system, or
 about completion of asynchronous tasks started using REST.

=== debian/rules ===
#!/usr/bin/make -f
export PYBUILD_NAME=zhmcclient
export PYBUILD_TEST_PYTEST=1
export PYBUILD_BEFORE_TEST=cp PKG-INFO {build_dir}
export PYBUILD_AFTER_TEST=rm {build_dir}/PKG-INFO

%:
	dh $@ --with python3 --buildsystem=pybuild

=== debian/watch ===
version=3
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/zhmcclient/zhmcclient-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## zhmcclient 0.27.0

=== Makefile ===
# ------------------------------------------------------------------------------
# Makefile for zhmcclient project
#
# Supported OS platforms for this makefile:
#     Linux (any distro)
#     OS-X
#     Windows with UNIX-like env such as CygWin (with a UNIX-like shell and
#       Python in the UNIX-like env)
#     native Windows (with the native Windows command processor and Python in
#       Windows)
#
# Prerequisites for running this makefile:
#   These commands are used on all supported OS platforms. On native Windows,
#   they may be provided by UNIX-like environments such as CygWin:
#     make (GNU make)
#     python (via PYTHON_CMD, in the active Python environment)
#     pip (via PIP_CMD, in the active Python environment)
#     twine (in the active Python environment)
#   These additional commands are used on Linux, OS-X and on Windows with
#   UNIX-like environments:
#     uname
#     rm, find, xargs, cp
#   These additional commands are used on native Windows:
#     del, copy, rmdir
# ------------------------------------------------------------------------------

# No built-in rules needed:
MAKEFLAGS += --no-builtin-rules
.SUFFIXES:

# Python / Pip commands
ifndef PYTHON_CMD
  PYTHON_CMD := python
endif
ifndef PIP_CMD
  PIP_CMD := pip
endif

# Package level
ifndef PACKAGE_LEVEL
  PACKAGE_LEVEL := latest
endif
ifeq ($(PACKAGE_LEVEL),minimum)
  pip_level_opts := -c minimum-constraints.txt
  pip_level_opts_new :=
else
  ifeq ($(PACKAGE_LEVEL),latest)
    pip_level_opts := --upgrade
    pip_level_opts_new := --upgrade-strategy eager
  else
    $(error Error: Invalid value for PACKAGE_LEVEL variable: $(PACKAGE_LEVEL))
  endif
endif

# Make variables are case sensitive and some native Windows environments have
# ComSpec set instead of COMSPEC.
ifndef COMSPEC
  ifdef ComSpec
    COMSPEC = $(ComSpec)
  endif
endif

# Determine OS platform make runs on.
ifeq ($(OS),Windows_NT)
  ifdef PWD
    PLATFORM := Windows_UNIX
  else
    PLATFORM := Windows_native
    ifdef COMSPEC
      SHELL := $(subst \,/,$(COMSPEC))
    else
      SHELL := cmd.exe
    endif
    .SHELLFLAGS := /c
  endif
else
  # Values: Linux, Darwin
  PLATFORM := $(shell uname -s)
endif

ifeq ($(PLATFORM),Windows_native)
  # Note: The substituted backslashes must be doubled.
  # Remove files (blank-separated list of wildcard path specs)
  RM_FUNC = del /f /q $(subst /,\\,$(1))
  # Remove files recursively (single wildcard path spec)
  RM_R_FUNC = del /f /q /s $(subst /,\\,$(1))
  # Remove directories (blank-separated list of wildcard path specs)
  RMDIR_FUNC = rmdir /q /s $(subst /,\\,$(1))
  # Remove directories recursively (single wildcard path spec)
  RMDIR_R_FUNC = rmdir /q /s $(subst /,\\,$(1))
  # Copy a file, preserving the modified date
  CP_FUNC = copy /y $(subst /,\\,$(1)) $(subst /,\\,$(2))
  ENV = set
  WHICH = where
else
  RM_FUNC = rm -f $(1)
  RM_R_FUNC = find . -type f -name '$(1)' -delete
  RMDIR_FUNC = rm -rf $(1)
  RMDIR_R_FUNC = find . -type d -name '$(1)' | xargs -n 1 rm -rf
  CP_FUNC = cp -r $(1) $(2)
  ENV = env | sort
  WHICH = which
endif

# Directory with hmc_definitions.yaml file for end2end tests
default_test_hmc_dir := tests
ifndef TESTHMCDIR
  TESTHMCDIR := $(default_test_hmc_dir)
endif

# Nickname of test HMC in hmc_definitions.yaml file for end2end tests
default_test_hmc := default
ifndef TESTHMC
  TESTHMC := $(default_test_hmc)
endif

# Name of this Python package (top-level Python namespace + Pypi package name)
package_name := zhmcclient
mock_package_name := zhmcclient_mock

# Package version (full version, including any pre-release suffixes, e.g. "0.1.0.dev1")
# Note: The package version is defined in zhmcclient/_version.py.
package_version := $(shell $(PYTHON_CMD) setup.py --version)

# Python versions
python_version := $(shell $(PYTHON_CMD) tools/python_version.py 3)
python_mn_version := $(shell $(PYTHON_CMD) tools/python_version.py 2)
python_m_version := $(shell $(PYTHON_CMD) tools/python_version.py 1)
pymn := py$(python_mn_version)

# Directory for the generated distribution files
dist_dir := dist

# Distribution archives (as built by setup.py)
bdist_file := $(dist_dir)/$(package_name)-$(package_version)-py2.py3-none-any.whl
sdist_file := $(dist_dir)/$(package_name)-$(package_version).tar.gz

# Windows installable (as built by setup.py)
win64_dist_file := $(dist_dir)/$(package_name)-$(package_version).win-amd64.exe

# dist_files := $(bdist_file) $(sdist_file) $(win64_dist_file)
dist_files := $(bdist_file) $(sdist_file)

# Source files in the packages
package_py_files := \
    $(wildcard $(package_name)/*.py) \
    $(wildcard $(package_name)/*/*.py) \
    $(wildcard $(mock_package_name)/*.py) \
    $(wildcard $(mock_package_name)/*/*.py) \

# Directory for generated API documentation
doc_build_dir := build_doc

# Directory where Sphinx conf.py is located
doc_conf_dir := docs

# Documentation generator command
doc_cmd := sphinx-build
doc_opts := -v -d $(doc_build_dir)/doctrees -c $(doc_conf_dir) .

# Dependents for Sphinx documentation build
doc_dependent_files := \
    $(doc_conf_dir)/conf.py \
    $(wildcard $(doc_conf_dir)/*.rst) \
    $(wildcard $(doc_conf_dir)/notebooks/*.ipynb) \
    $(package_py_files) \

# Directory with test source files
test_dir := tests

# Source files with test code
test_unit_py_files := \
    $(wildcard $(test_dir)/unit/*.py) \
    $(wildcard $(test_dir)/unit/*/*.py) \
    $(wildcard $(test_dir)/unit/*/*/*.py) \

test_end2end_py_files := \
    $(wildcard $(test_dir)/end2end/*.py) \
    $(wildcard $(test_dir)/end2end/*/*.py) \
    $(wildcard $(test_dir)/end2end/*/*/*.py) \

test_common_py_files := \
    $(wildcard $(test_dir)/common/*.py) \
    $(wildcard $(test_dir)/common/*/*.py) \
    $(wildcard $(test_dir)/common/*/*/*.py) \

# Determine whether py.test has the --no-print-logs option.
pytest_no_log_opt := $(shell py.test --help 2>/dev/null |grep '\--no-print-logs' >/dev/null; if [ $$? -eq 0 ]; then echo '--no-print-logs'; else echo ''; fi)

# Flake8 config file
flake8_rc_file := .flake8

# PyLint config file
pylint_rc_file := .pylintrc

# PyLint additional options
pylint_opts := --disable=fixme

# Source files for check (with PyLint and Flake8)
check_py_files := \
    setup.py \
    $(package_py_files) \
    $(test_unit_py_files) \
		$(test_end2end_py_files) \
		$(test_common_py_files) \
		$(doc_conf_dir)/conf.py \
    $(wildcard docs/notebooks/*.py) \
    $(wildcard tools/cpcinfo) \
    $(wildcard tools/cpcdata) \

ifdef TESTCASES
  pytest_opts := $(TESTOPTS) -k $(TESTCASES)
else
  pytest_opts := $(TESTOPTS)
endif

# Files to be built
ifeq ($(PLATFORM),Windows_native)
build_files := $(bdist_file) $(sdist_file) $(win64_dist_file)
else
build_files := $(bdist_file) $(sdist_file)
endif

# Files the distribution archive depends upon.
# This is also used for 'include' statements in MANIFEST.in.
# Wildcards can be used directly (i.e. without wildcard function).
dist_included_files := \
    setup.py \
    LICENSE \
    README.rst \
    requirements.txt \
    $(package_py_files) \

# No built-in rules needed:
.SUFFIXES:

.PHONY: help
help:
	@echo "Makefile for $(package_name) project"
	@echo "Package version will be: $(package_version)"
	@echo ""
	@echo "Make targets:"
	@echo "  install    - Install package in active Python environment"
	@echo "  develop    - Prepare the development environment by installing prerequisites"
	@echo "  check      - Run Flake8 on sources"
	@echo "  pylint     - Run PyLint on sources"
	@echo "  test       - Run unit tests (and test coverage)"
	@echo "  installtest - Run install tests"
	@echo "  build      - Build the distribution files in: $(dist_dir)"
	@echo "  builddoc   - Build documentation in: $(doc_build_dir)"
	@echo "  all        - Do all of the above"
	@echo "  end2end    - Run end2end tests"
	@echo "  uninstall  - Uninstall package from active Python environment"
	@echo "  upload     - Upload the distribution files to PyPI"
	@echo "  clean      - Remove any temporary files"
	@echo "  clobber    - Remove any build products"
	@echo "  platform   - Display the information about the platform as seen by make"
	@echo "  debuginfo  - Display the debug information for the package"
	@echo "  env        - Display the environment as seen by make"
	@echo ""
	@echo "Environment variables:"
	@echo "  TESTCASES=... - Testcase filter for pytest -k"
	@echo "  TESTOPTS=... - Options for pytest"
	@echo "  TESTHMC=... - Nickname of HMC to be used in end2end tests. Default: $(default_test_hmc)"
	@echo "  TESTHMCDIR=... - Path name of directory with hmc_definitions.yaml file for end2end tests. Default: $(default_test_hmc_dir)"
	@echo "  TESTLOGFILE=... - Enable logging in end2end tests to that file. Default: no logging"
	@echo "  PACKAGE_LEVEL - Package level to be used for installing dependent Python"
	@echo "      packages in 'install' and 'develop' targets:"
	@echo "        latest - Latest package versions available on Pypi"
	@echo "        minimum - A minimum version as defined in minimum-constraints.txt"
	@echo "      Optional, defaults to 'latest'."
	@echo "  PYTHON_CMD=... - Name of python command. Default: python"
	@echo "  PIP_CMD=... - Name of pip command. Default: pip"

.PHONY: platform
platform:
	@echo "Makefile: Platform information as seen by make:"
	@echo "Platform: $(PLATFORM)"
	@echo "Shell used for commands: $(SHELL)"
	@echo "Shell flags: $(.SHELLFLAGS)"
	@echo "Make version: $(MAKE_VERSION)"
	@echo "Python command name: $(PYTHON_CMD)"
	@echo "Python command location: $(shell $(WHICH) $(PYTHON_CMD))"
	@echo "Python version: $(python_version)"
	@echo "Pip command name: $(PIP_CMD)"
	@echo "Pip command location: $(shell $(WHICH) $(PIP_CMD))"
	@echo "$(package_name) package version: $(package_version)"

.PHONY: debuginfo
debuginfo:
	@echo "Makefile: Debug information:"
	$(PYTHON_CMD) -m $(package_name).debuginfo

.PHONY: pip_list
pip_list:
	@echo "Makefile: Python packages as seen by make:"
	$(PIP_CMD) list

.PHONY: env
env:
	@echo "Makefile: Environment variables as seen by make:"
	$(ENV)

.PHONY: _check_version
_check_version:
ifeq (,$(package_version))
	$(error Package version could not be determined)
endif

pip_upgrade_$(pymn).done: Makefile
	-$(call RM_FUNC,$@)
	$(PYTHON_CMD) tools/remove_duplicate_setuptools.py
	@echo "Installing/upgrading pip, setuptools and wheel with PACKAGE_LEVEL=$(PACKAGE_LEVEL)"
	$(PYTHON_CMD) -m pip install $(pip_level_opts) pip setuptools wheel
	echo "done" >$@

.PHONY: develop
develop: develop_$(pymn).done
	@echo "Makefile: $@ done."

develop_$(pymn).done: pip_upgrade_$(pymn).done install_$(pymn).done dev-requirements.txt requirements.txt
	-$(call RM_FUNC,$@)
	@echo 'Installing development requirements with PACKAGE_LEVEL=$(PACKAGE_LEVEL)'
	$(PIP_CMD) install $(pip_level_opts) $(pip_level_opts_new) -r dev-requirements.txt
	echo "done" >$@

.PHONY: build
build: $(build_files)
	@echo "Makefile: $@ done."

.PHONY: builddoc
builddoc: html
	@echo "Makefile: $@ done."

.PHONY: html
html: $(doc_build_dir)/html/docs/index.html
	@echo "Makefile: $@ done."

$(doc_build_dir)/html/docs/index.html: Makefile develop_$(pymn).done $(doc_dependent_files)
	-$(call RM_FUNC,$@)
	$(doc_cmd) -b html $(doc_opts) $(doc_build_dir)/html
	@echo "Done: Created the HTML pages with top level file: $@"

.PHONY: pdf
pdf: Makefile develop_$(pymn).done $(doc_dependent_files)
	$(doc_cmd) -b latex $(doc_opts) $(doc_build_dir)/pdf
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(doc_build_dir)/pdf all-pdf
	@echo "Done: Created the PDF files in: $(doc_build_dir)/pdf/"
	@echo "Makefile: $@ done."

.PHONY: man
man: Makefile develop_$(pymn).done $(doc_dependent_files)
	$(doc_cmd) -b man $(doc_opts) $(doc_build_dir)/man
	@echo "Done: Created the manual pages in: $(doc_build_dir)/man/"
	@echo "Makefile: $@ done."

.PHONY: docchanges
docchanges:
	$(doc_cmd) -b changes $(doc_opts) $(doc_build_dir)/changes
	@echo
	@echo "Done: Created the doc changes overview file in: $(doc_build_dir)/changes/"

=== requirements.txt ===
--- 
+++ 
@@ -10,17 +10,17 @@
 
 # Direct dependencies (except pip, setuptools, wheel):
 
-decorator>=4.0.10 # new BSD
-pbr>=1.10.0 # Apache-2.0
+decorator>=4.0.11 # new BSD
 pytz>=2016.10 # MIT
-requests>=2.20.0 # Apache-2.0
-six>=1.10.0 # MIT
-stomp.py>=4.1.15 # Apache
-
+requests>=2.20.1 # Apache-2.0
+six>=1.14.0 # MIT
+stomp.py>=4.1.23,<5.0.0; python_version == '2.7'  # Apache
+stomp.py>=4.1.23; python_version > '2.7'  # Apache
 
 # Indirect dependencies (commented out, only listed to document their license):
 
 # certifi # ISC, from requests>=2.20
 # chardet # LGPL, from requests>=2.20
+# docopt # MIT, from stomp.py>=4.1
 # idna # BSD-like, from requests>=2.20
 # urllib3 # MIT, from requests>=2.20

=== debian/changelog ===
zhmcclient (0.27.0-0ubuntu1) hirsute; urgency=medium

  * New upstream release. LP: #1907536
  * Use github tarball
  * Do not run tests, needs HMC credentials

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 10 Dec 2020 16:46:54 +0000

zhmcclient (0.22.0-0ubuntu2) groovy; urgency=medium

  * Fix FTBFS by backporting a fix from upstream.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 05 Oct 2020 14:03:47 +1300

## zhmcclient 0.31.0

=== requirements.txt ===
--- 
+++ 
@@ -10,12 +10,22 @@
 
 # Direct dependencies (except pip, setuptools, wheel):
 
-decorator>=4.0.11 # new BSD
+# decorator 5.0.0 removed support for Python 2.7 and 3.4
+decorator>=4.0.11,<5.0; python_version <= '3.4'  # new BSD
+decorator>=4.0.11; python_version >= '3.5'  # new BSD
 pytz>=2016.10 # MIT
-requests>=2.20.1 # Apache-2.0
+# requests 2.22.0 removed support for Python 3.4
+requests>=2.20.1; python_version == '2.7'  # Apache-2.0
+requests>=2.20.1,<2.22.0; python_version == '3.4'  # Apache-2.0
+requests>=2.20.1; python_version >= '3.5'  # Apache-2.0
 six>=1.14.0 # MIT
-stomp.py>=4.1.23,<5.0.0; python_version == '2.7'  # Apache
-stomp.py>=4.1.23; python_version > '2.7'  # Apache
+# stomp.py 5.0.0 (now deleted) and 6.0.0 removed support for Python 2.7, 3.4 and 3.5
+# stomp.py 6.1.0 on Pypi contained older code than v6.1.0 in the repo -> will be yanked on Pypi
+# stomp.py 6.1.1 broke compatibility -> will be yanked on Pypi and re-released as 7.0.0
+stomp.py>=4.1.23,<5.0.0; python_version <= '3.5'  # Apache
+stomp.py>=4.1.23,<7.0.0,!=6.1.0,!=6.1.1; python_version >= '3.6'  # Apache
+
+immutable-views>=0.6.0
 
 # Indirect dependencies (commented out, only listed to document their license):

=== debian/changelog ===
zhmcclient (0.31.0-0ubuntu3~20.04.1) focal; urgency=medium

  * Backporting new upstream release. (LP: #1919451)

 -- Lukas Märdian <slyon@ubuntu.com>  Thu, 22 Jul 2021 15:11:31 +0200

=== debian/control ===
--- 
+++ 
@@ -22,7 +22,10 @@
 
 Package: python3-zhmcclient
 Architecture: all
-Depends: ${python3:Depends}, ${misc:Depends}
+Depends: python3-requests,
+ python3-decorator,
+ ${python3:Depends},
+ ${misc:Depends}
 Description: library for the IBM Z HMC Web Services API
  The HMC Web Services API is the access point for any external tools
  to manage the IBM Z or LinuxONE platform. It supports management of

## zhmcclient 1.5.0

=== requirements.txt ===
--- 
+++ 
@@ -10,22 +10,47 @@
 
 # Direct dependencies (except pip, setuptools, wheel):
 
-# decorator 5.0.0 removed support for Python 2.7 and 3.4
-decorator>=4.0.11,<5.0; python_version <= '3.4'  # new BSD
+# decorator 5.0.0 removes support for Python 2.7 and 3.4
+decorator>=4.0.11,<5.0; python_version == '2.7'  # new BSD
 decorator>=4.0.11; python_version >= '3.5'  # new BSD
-pytz>=2016.10 # MIT
-# requests 2.22.0 removed support for Python 3.4
-requests>=2.20.1; python_version == '2.7'  # Apache-2.0
-requests>=2.20.1,<2.22.0; python_version == '3.4'  # Apache-2.0
-requests>=2.20.1; python_version >= '3.5'  # Apache-2.0
-six>=1.14.0 # MIT
+
+# pytz 2019.1 fixes an ImportError for collections.Mapping on Python 3.10
+pytz>=2016.10; python_version <= '3.9'  # MIT
+pytz>=2019.1; python_version >= '3.10'  # MIT
+
+# requests 2.22.0 removes the pinning of urllib3 to <1.25.0, and urllib 1.25.9
+#   is required to address safety issues
+# requests 2.25.0 tolerates urllib3 1.26.5 which is needed on Python 3.10 to
+#   remove ImportWarning in six
+requests>=2.22.0; python_version <= '3.9'  # Apache-2.0
+requests>=2.25.0; python_version >= '3.10'  # Apache-2.0
+
+# six 1.16.0 removes the ImportWarning raised by Python 3.10
+six>=1.14.0; python_version <= '3.9'  # MIT
+six>=1.16.0; python_version >= '3.10'  # MIT
+
 # stomp.py 5.0.0 (now deleted) and 6.0.0 removed support for Python 2.7, 3.4 and 3.5
 # stomp.py 6.1.0 on Pypi contained older code than v6.1.0 in the repo -> will be yanked on Pypi
 # stomp.py 6.1.1 broke compatibility -> will be yanked on Pypi and re-released as 7.0.0
 stomp.py>=4.1.23,<5.0.0; python_version <= '3.5'  # Apache
 stomp.py>=4.1.23,<7.0.0,!=6.1.0,!=6.1.1; python_version >= '3.6'  # Apache
 
+python-dateutil>=2.8.0
 immutable-views>=0.6.0
+nocasedict>=1.0.2
+
+# PyYAML pulled in by zhmcclient_mock (and zhmcclient examples, and python-coveralls)
+# PyYAML 5.3 fixes narrow build error
+# PyYAML 6.0 removed support for py27,35
+PyYAML>=5.3
+
+# yamlloader pulled in by zhmcclient_mock and zhmcclient.testutils
+# yamlloader 1.0 removed support for py27,35
+yamlloader>=0.5.5
+
+# jsonschema pulled in by zhmcclient_mock and zhmcclient.testutils
+# jsonschema 4.0 removed support for py27,35,36
+jsonschema>=2.6.0
 
 # Indirect dependencies (commented out, only listed to document their license):
 
@@ -34,3 +59,4 @@
 # docopt # MIT, from stomp.py>=4.1
 # idna # BSD-like, from requests>=2.20
 # urllib3 # MIT, from requests>=2.20
+# pyrsistent # MIT, from jsonschema>=3.0

=== debian/changelog ===
zhmcclient (1.5.0-0ubuntu1) lunar; urgency=medium

  * New upstream release. LP: #2006944
  * Modify d/p/0001-Revert-Changed-properties-attribute-to-be-immutable.patch
    and transfer it into an independent patch:
    d/p/Changing-properties-attribute-back-to-be-not-immutable.patch since the
    changes for the latest version became far more than just reverting
    commit 5c24a01984ea95c03977e5b47f7f17eb33b0150f.
  * Remove './docs/_static/*.css' entry from d/copyright, since the referenced
    folder does not exist anymore.
  * Update 'Standards-Version' in d/control to latest 4.6.1.0.
  * Migrate debian/watch from version 3 to 4.
  * Update copyright years in debian/changelog.

 -- Frank Heimes <frank.heimes@canonical.com>  Thu, 09 Feb 2023 12:52:20 +0100

zhmcclient (0.31.0-0ubuntu3) impish; urgency=medium

  * d/control: fix armhf autopkgtest by adding python3-requests dependency

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 21 Jun 2021 18:16:51 +0200

zhmcclient (0.31.0-0ubuntu2) impish; urgency=medium

  * d/control: add python3-decorator runtime dependency
  * Add d/p/0001-Revert-Changed-properties-attribute-to-be-immutable.patch
    To avoid the new immutable_views dependency

 -- Lukas Märdian <slyon@ubuntu.com>  Mon, 21 Jun 2021 09:22:44 +0200

zhmcclient (0.31.0-0ubuntu1) impish; urgency=medium

  * New upstream release. LP: #1919451
  * Use github tarball

 -- Matthieu Clemenceau <matthieu.clemenceau@canonical.com>  Thu, 17 Jun 2021 19:13:32 -0500

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  python3-testfixtures,
  python3-pbr,
  python3-mock,
-Standards-Version: 4.1.3
+Standards-Version: 4.6.1.0
 Homepage: https://github.com/zhmcclient/python-zhmcclient
 Testsuite: autopkgtest-pkg-python

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/zhmcclient/zhmcclient-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
